#!/usr/local/bin/perl
#########################################################
#                                                       #
#                     Go2! Search                       #
#                                                       #
#########################################################
#                                                       #
#                      search.pl                        #
#                                                       #
#   If needed, change the paths to the required files   #
#   below. Upload in ASCII and CHMOD this script 755.   #
#                                                       #
#   If you have any further questions, direct them to   #
#   the support forum at http://www.go2cgi.com/         #
#                                                       #
#########################################################
#                                                       #
#         Copyright  1999 W. Dustin Alligood           #
#                                                       #
#########################################################

require "config.txt";
require "text.txt";
require "plugins.txt";

# Change nothing below this line
#########################################################

$adultwords=~s/, ?/\|/gi;
@cats=split(/}{/,$cats);
if($ENV{'QUERY_STRING'} ne ''){
	$buffer=$ENV{'QUERY_STRING'};
}else{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
}
@pairs=split(/&/,$buffer); 
foreach $pair (@pairs) { 
	($name, $value)=split(/=/,$pair); 
	$value =~ tr/+/ /;
	$value=~s/%25spa%25/%spa%/gi;
	$value=~s/%25amp%25/%amp%/gi;
	$value=~s/%25pip%25/%pip%/gi;
	$value=~s/%3A/:/gi;
	$value=~s/%2F/\//gi;
	$value=~s/%20/ /;
	$value=~s/%2B/\+/gi;
	$value=~s/%28/\(/gi;
	$value=~s/%29/\)/gi;
	$value=~s/%DF//gi;
	$value=~s/%FC//gi;
	$value=~s/%F6//gi;
	$value=~s/%EB//gi;
	$value=~s/%E4//gi;
	$value=~s/%D6//gi;
	$value=~s/%DC//gi;
	$value=~s/%CB//gi;
	$value=~s/%C4//gi;
	$value=~s/%A2//gi;
	$value=~s/%24/\$/gi;
	$value=~s/%2C/,/gi;
	$value=~s/%7C/\|/gi;
	$value=~s/%26/\&/gi;
	$value=~s/%7E/~/gi;
	$value=~s/%21/!/gi;
	$f{$name}=$value; 
}
if($f{'action'} eq 'addurl'){
	&AddURL;
}elsif($f{'action'} eq 'rate'){
	&Rate1;
}elsif($f{'action'} eq 'powersearch'){
	&Powersearch;
}elsif($f{'action'} eq 'parsesearch'){
	&Parsesearch;
}elsif($f{'action'} eq 'rate2'){
	&Rate2;
}elsif($f{'action'} eq 'search'){
	&Search;
}elsif($f{'action'} eq 'spider'){
	&Spider;
}elsif($f{'action'} eq 'cat'){
	&BrowseCat;
}elsif($f{'action'} eq 'click'){
	&URLClick;
}elsif($f{'action'} eq 'homeclick'){
	&HomeClick;
}elsif($f{'action'} eq 'showreframe'){
	&ShowReFrame;
}elsif($f{'action'} eq 'tips'){
	&ShowTips;
}else{
	&HomePage;
}
sub HomePage{
	&Plugin('homepage');
	open(FILE,"<$home");
	flock(FILE,2);
	@data=<FILE>;
	close(FILE);
	$text{'searchbox'} ="<table border=0 cellpadding=0 cellspacing=0>";
	$text{'searchbox'}.="<form action=\"$script\" method=$searchmethod><tr><td align=center>";
	$text{'searchbox'}.="<input type=hidden name=action value=search>\n";
	if($famdefault eq "yes"){
		$text{'searchbox'}.="<input type=hidden name=adult value=no>\n";
	}else{
		$text{'searchbox'}.="<input type=hidden name=adult value=yes>\n";
	}
	$text{'searchbox'}.="<input type=hidden name=fivestar value=no>\n";
	$text{'searchbox'}.="&nbsp;<input type=text size=30 name=\"terms\">";
	$text{'searchbox'}.="<input type=Submit value=\"$button{'search'}\">&nbsp;<br>\n";
	$text{'searchbox'}.="<a href=\"$script?action=powersearch\">";
	$text{'searchbox'}.="<font color=darkblue face=Arial size=\"-1\"><u>";
	$text{'searchbox'}.="$link{'powersearch'}</u></font></a> | <u>";
	if($adminadd ne 'yes'){
		$text{'searchbox'}.="<a href=\"$script?action=addurl\"><font color=darkblue face=Arial size=\"-1\">$link{'addurl'}</font></a></u> | <u>";
	}
	$text{'searchbox'}.="<a href=\"$script?action=tips\">";
	$text{'searchbox'}.="<font color=darkblue face=Arial size=\"-1\">";
	$text{'searchbox'}.="$link{'tips'}</font></a></u></font>\n";
	$text{'searchbox'}.="</td></tr></form></table>\n";
	use LWP::Simple;
	$doc = get "http://abcnews.go.com/";
	@abc=split(/\n/,$doc);
	$rcd=0;
	$news="";
	foreach $line (@abc){
		$ft=substr "$line","",7; 
		if($rcd==1){
			if($line!~/font/){
				if($ft ne '<!-- Wo'){
					$news="$news\n<tr><td valign=top><font size=-1></font></td><td valign=top>$line</td></tr>";
				}
			}else{
				if($line!~/<\/font>/){
					$news="$news\n$line";
				}
			}
		}
		if ($ft eq '<B>W O '){
			$rcd=1;
		}elsif($ft eq '</font>'){
			$rcd=0;
		}
	}
	$text{'abcnews'} ="<p><center><table border=0 cellpadding=0 cellspacing=2>\n";
	$news=~s/html\">/html\"><font size=-1>/gi;
	$news=~s/<\/a>/<\/a><\/font>/gi;
	$text{'abcnews'}.="$news</table><br><font size=-2>World News from</font><br><font size=-1><a href=http://abcnews.go.com/><font color=blue>ABC</font><font color=black>NEWS.com</font></font></a></center></p>";
	@categories=split(/}{/,$cats);
	@catdescs=split(/}{/,$catdesc);
	$nms=@categories;
	$n3=-1;
	$tablewidth=$catwidth*$catcols;
	$text{'catlink'}="<table border=0 cellpadding=3 width=$tablewidth>\n";
	for ($n4=0;$n4<=$#categories/$catcols;$n4++){
		$text{'catlink'}.="<tr>\n";		
		for($n1=1;$n1<=$catcols;$n1++){
			$showsubs="";
			$n3++;
			($category,$subcategories)=split(/\|/,@categories[$n3]);
			$cathref=$category;
			($catdesc,$subcatdesc)=split(/\|/,@catdescs[$n3]);
			if($subcatlinks eq "1"){
				@subcats=split(/,/,$subcategories);
				for($i=1;$i<4;$i++){
					if($#subcats+1>=$i){
						$subhref="$category|@subcats[$i-1]";
						chomp($subhref);
						$subhref=~s/ /%spa%/gi;
						$subhref=~s/\&/%amp%/gi;
						$subhref=~s/\|/%pip%/gi;
						$showsubs.="<a href=\"$script?action=cat&name=$subhref\">@subcats[$i-1]</a>";
						if(($i<$#subcats+1)&&($i<3)){
							$showsubs.=", ";
						}else{
							if($#subcats>2){
								$showsubs.="...";
							}
						}
					}
				}
			}else{
				$showsubs="$catdesc";
			}
			chomp($cathref);
			$cathref=~s/ /%spa%/gi;
			$cathref=~s/\&/%amp%/gi;
			$cathref=~s/\|/%pip%/gi;
			$text{'catlink'}.="<td width=$catwidth valign=top><a href=\"$script?action=cat&name=$cathref\"><b>$category</b></a><br><font size=-1>$showsubs</font></td>\n";
		}
		$text{'catlink'}.="</tr>\n";
	}
	$text{'catlink'}.="</table>\n";
	open(FILE,"<$lastsub");
	flock(FILE,2);
	@lastdata=<FILE>;
	close(FILE);
	@lastdata[2]=substr "@lastdata[2]","",60; 
	chomp(@lastdata[2]);
	if(chop(@lastdata[2]) eq " "){
		chop(@lastdata[2]);
	}
	chomp(@lastdata[1]);
	chomp(@lastdata[0]);
	$uterm=@lastdata[1];
	$uterm=~s/:/%3A/gi;
	$uterm=~s/\//%2F/gi;
	$uterm=~s/\+/%2B/gi;
	$uterm=~s/ /\+/gi;
	$uterm=~s/\(/%28/gi;
	$uterm=~s/\)/%29/gi;
	$uterm=~s//%DF/gi;
	$uterm=~s//%FC/gi;
	$uterm=~s//%F6/gi;
	$uterm=~s//%EB/gi;
	$uterm=~s//%E4/gi;
	$uterm=~s//%D6/gi;
	$uterm=~s//%DC/gi;
	$uterm=~s//%CB/gi;
	$uterm=~s//%C4/gi;
	$uterm=~s//%A2/gi;
	$uterm=~s/\$/%24/gi;
	$uterm=~s/,/%2C/gi;
	$uterm=~s/~/%7E/gi;
	$text{'lastsub'}="<a href=\"$script?action=homeclick&url=@lastdata[0]&title=$uterm\"><b>@lastdata[1]</b></a><br>@lastdata[2]...";
	print "Content-type:text/html\n\n";
	foreach $line (@data){
		chomp($line);
		$line=~s/<!--#searchbox-->/$text{'searchbox'}/gi;
		$line=~s/<!--#lastsub-->/$text{'lastsub'}/gi;
		$line=~s/<!--#abcnews-->/$text{'abcnews'}/gi;
		$line=~s/<!--#category-->/$text{'catlink'}/gi;
		print "$line\n";
	}
}
sub Parsesearch{
	if($f{'type'} eq 'phrase'){
		$term="($f{'phrase'}) ";
	}else{
		for($i=0;$i<10;$i++){
			if($f{"term$i"} ne ""){
				$term.=$f{"cas$i"};
				$term.=$f{"term$i"};
				$term.=" ";
			}
		}
	}
	if($f{'case'} eq "sensitive"){
		$c="sen";
	}else{
		$c="in";
	}
	if($f{'adult'} eq "yes"){
		$a="no";
	}else{
		$a="yes";
	}
	if($f{'fivestar'} eq "yes"){
		$f="yes";
	}else{
		$f="no";
	}
	chomp($term);
	chop($term);
	$term=~s/%spa%/%25spa%25/gi;
	$term=~s/%amp%/%25amp%25/gi;
	$term=~s/%pip%/%25pip%25/gi;
	$term=~s/:/%3A/gi;
	$term=~s/\//%2F/gi;
	$term=~s/\+/%2B/gi;
	$term=~s/ /\+/gi;
	$term=~s/\(/%28/gi;
	$term=~s/\)/%29/gi;
	$term=~s//%DF/gi;
	$term=~s//%FC/gi;
	$term=~s//%F6/gi;
	$term=~s//%EB/gi;
	$term=~s//%E4/gi;
	$term=~s//%D6/gi;
	$term=~s//%DC/gi;
	$term=~s//%CB/gi;
	$term=~s//%C4/gi;
	$term=~s//%A2/gi;
	$term=~s/\$/%24/gi;
	$term=~s/,/%2C/gi;
	$term=~s/~/%7E/gi;
	$term=~s/\?/%3F/gi;
	print "Location:$script?action=search&terms=$term&case=$c&adult=$a&fivestar=$f\n\n";
}
sub Powersearch{
	print "Content-type: text/html\n\n";
	$|++;
	print "<html><head><title>$title: $title{'powersearch'}</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=powersearch\"><font size=+1 $navbarfont>$text{'powersearch'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	&Banner('general');
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"parsesearch\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'powersearch'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<p><center><table border=0><tr><td width=20 valign=top>";
	print "<input type=radio name=type value=phrase>\n";
	print "</td><td valign=top>\n";
	print "<b>$text{'phrase'}</b><br><input type=text name=phrase value=\"\" size=36>\n";
	print "</td><td rowspan=2 width=5></td><td rowspan=2 width=170 valign=top>\n";
	print "<p><input type=checkbox name=case value=sensitive>$text{'case'}</p>\n";
	if($familysafe eq "yes"){
		print "<p><input type=checkbox name=adult value=yes";
		if($famdefault eq "yes"){
			print " checked";
		}
		print ">$text{'famsearch'}</p>\n";
	}
	if($fivestar eq "yes"){
		print "<p><input type=checkbox name=fivestar value=yes>$text{'fivestar'}</p>\n";
	}
	print "<p><center><input type=submit value=\"$button{'powersearch'}\"></center></td></tr>\n";
	print "<tr><td width=20 valign=top>\n";
	print "<input type=radio name=type value=terms checked>\n";
	print "</td><td valign=top>\n";
	print "<b>$text{'constraints'}</b><br>\n";
	print "<select name=cas0><option value=\"+\" selected>$text{'mustcontain'}<option value=\"-\">$text{'cannotcontain'}</select> <input type=text name=term0 value=\"\" size=20><br>\n";
	print "<select name=cas1><option value=\"+\" selected>$text{'mustcontain'}<option value=\"-\">$text{'cannotcontain'}</select> <input type=text name=term1 value=\"\" size=20><br>\n";
	print "<select name=cas2><option value=\"+\" selected>$text{'mustcontain'}<option value=\"-\">$text{'cannotcontain'}</select> <input type=text name=term2 value=\"\" size=20><br>\n";
	print "<select name=cas3><option value=\"+\" selected>$text{'mustcontain'}<option value=\"-\">$text{'cannotcontain'}</select> <input type=text name=term3 value=\"\" size=20><br>\n";
	print "<select name=cas4><option value=\"+\" selected>$text{'mustcontain'}<option value=\"-\">$text{'cannotcontain'}</select> <input type=text name=term4 value=\"\" size=20><br>\n";
	print "<select name=cas5><option value=\"+\">$text{'mustcontain'}<option value=\"-\" selected>$text{'cannotcontain'}</select> <input type=text name=term5 value=\"\" size=20><br>\n";
	print "<select name=cas6><option value=\"+\">$text{'mustcontain'}<option value=\"-\" selected>$text{'cannotcontain'}</select> <input type=text name=term6 value=\"\" size=20><br>\n";
	print "<select name=cas7><option value=\"+\">$text{'mustcontain'}<option value=\"-\" selected>$text{'cannotcontain'}</select> <input type=text name=term7 value=\"\" size=20><br>\n";
	print "<select name=cas8><option value=\"+\">$text{'mustcontain'}<option value=\"-\" selected>$text{'cannotcontain'}</select> <input type=text name=term8 value=\"\" size=20><br>\n";
	print "<select name=cas9><option value=\"+\">$text{'mustcontain'}<option value=\"-\" selected>$text{'cannotcontain'}</select> <input type=text name=term9 value=\"\" size=20>\n";
	print "</td></tr></table></center></p>\n";
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=powersearch\"><font size=+1 $navbarfont>$text{'powersearch'}</font></a>";
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
}
sub ShowTips{
	print "Content-type: text/html\n\n";
	$|++;
	print "<html><head><title>$title: $title{'tips'}</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=tips\"><font size=+1 $navbarfont>$title{'tips'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	&Banner('general');
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"parsesearch\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'tips'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "$text{'tips'}\n";
	print "</td></tr></table>\n";
	print "</td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=tips\"><font size=+1 $navbarfont>$title{'tips'}</font></a>";
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
}
sub Search{
	print "Content-type: text/html\n\n";
	$|++;
	$terms=$f{'terms'};
	$terms=~s/%(..)/pack("c",hex($1))/ge;
	$limit=$f{'limit'};
	$case=$f{'case'};
	$amt=$f{'amt'};
	$terms=~s/ AND / \+/gi;
	$terms=~s/ NOT / \-/gi;
	$terms=~s/ OR /\|/gi;
	if($terms=~/\(.*\)/i){
		push(@and,$terms);
	}else{
		if(($terms!~/\+/g)&&($terms!~/\-/g)){
			$terms=~s/ / \+/g;
		}
		$first=substr "$terms","",1; 
		if(($first ne '+')&&($first ne '-')){
			$terms="+$terms";
		}
		@terms=split(/ /,$terms);
		foreach $item (@terms){
			if($item=~/\-/g){
				$item=~s/\-//gi;
				$item=~s/\+//gi;
				push(@not,$item);
			}else{
				$item=~s/\+//gi;
				$item=~s/\-//gi;
				push(@and,$item);
			}
		}
	}
	@categories=split(/}{/,$cats);
	foreach $category (@categories){
		$category=~s/ /%spa%/gi;
		$category=~s/\&/%amp%/gi;
		$category=~s/\|/%pip%/gi;
		($base,$subs)=split(/%pip%/,$category);
		@subdirs=split(/,/,$subs);
		open(FILE,"<$data/data_$base.txt");
		flock(FILE,2);
		@data=<FILE>;
		close(FILE);
		foreach $line (@data){
			chomp($line);
			push(@rawdata,$line);
		}
		foreach $sub (@subdirs){
			open(FILE,"<$data/data_$base%pip%$sub.txt");
			flock(FILE,2);
			@data=<FILE>;
			close(FILE);
			foreach $line (@data){
				chomp($line);
				push(@rawdata,$line);
			}			
		}
	}
	foreach $line (@rawdata){
		($clicks,$url,$stitle,$desc,$keys,$cat,$rate,$votes,$junk)=split(/}{/,$line);
		$searchdata="$url $stitle $desc $keys $cat";
		$include=0;
		foreach $and (@and){
			if($case eq "sen"){
				if($searchdata=~/$and/g){
					$include=1;
				}else{
					$include=0;
				}				
			}else{
				if($searchdata=~/$and/gi){
					$include=1;
				}else{
					$include=0;
				}
			}
		}
		foreach $not (@not){
			if($case eq "sen"){
				if($searchdata=~/$not/g){
					$include=0;
				}
			}else{
				if($searchdata=~/$not/gi){
					$include=0;
				}
			}
		}
		if($f{'adult'} eq 'no'){
			if($searchdata=~/$adultwords/gi){
				$include=0;
			}
		}
		if($f{'fivestar'} eq 'yes'){
			if(($rate!=0)&&($votes!=0)){
				if(int($rate/$votes)<5){
					$include=0;
				}
			}else{
				$include=0;
			}
		}
		if($include==1){
			push(@results,$line);
		}
	}
	@results=sort{$b <=> $a}(@results);
	$matchnum=$#results+1;
	$text{'matches'}=~s/##/$matchnum/;
	unshift(@results,$text{'matches'});
	&Plugin('search');
	$termshref=$terms;
	$termshref=~s/\+/%2B/;
	$termshref=~s/ /\+/;
	$tterms=$terms;
	$tterms=~s/\|/ > /gi;
	print "<html><head><title>$title: Search For: \"$tterms\"</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=search&terms=$termshref&adult=$f{'adult'}&fivestar=$f{'fivestar'}\"><font size=+1 $navbarfont>\"$terms\"</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$script?action=powersearch\"><font size=+1 $navbarfont>$text{'searchfor'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	&Banner("$terms");
	print "<center><table border=0 width=97%><tr><td valign=top>";
	if($amt<0){
		$amt=0;
	}
	if($amt>$#results){
		$amt=$#results;
	}
	$a2=$amt+10;
	$a1=$amt;
	if($a1<0){
		$a1=0;
	}
	$sitefound=0;
	for($i=$a1;$i<$a2;$i++){
		if(@results[$i]=~/}{/gi){
			($clicks,$url,$stitle,$desc,$keys,$category,$rate,$votes,$junk)=split(/}{/,@results[$i]);
			$url=~s/%(..)/pack("c",hex($1))/ge;
			$stitle=~s/%(..)/pack("c",hex($1))/ge;
			$desc=~s/%(..)/pack("c",hex($1))/ge;
			$keys=~s/%(..)/pack("c",hex($1))/ge;
			if(length($stitle)>$titletrunc){
				$stitle=substr "$stitle","",$titletrunc-3; 
				$stitle.="...";
			}
			if(length($url)>$urltrunc){
				$surl=substr "$url","",$urltrunc-3; 
				$surl.="...";
			}else{
				$surl=$url;
			}
			if(length($desc)==$desclength){
				$desc.="...";
			}
			$cathref=$category;
			$cathref=~s/ /%spa%/gi;
			$cathref=~s/\&/%amp%/gi;
			$cathref=~s/\|/%pip%/gi;
			$category=~s/%spa%/ /gi;
			$category=~s/%amp%/\&/gi;
			$category=~s/%pip%/\|/gi;	
			$sitefound++;
			if(($rez_cat eq "yes")||($rez_rate eq "yes")){
				print "<ul><li><table border=0 cellpadding=0 cellspacing=0 width=87%><tr><td valign=top><a href=\"$script?action=click&url=$url&cat=$cathref\"><b>$stitle</b></a></td><td align=right valign=top>";
				if($rez_rate eq "yes"){
					if(($rate==0)||($votes==0)){
						$rating=0;
					}else{
						$rating=int($rate/$votes);
						if($rating>5){
							$rating=5;
						}
					}
					if($rating!=0){
						for($n=0;$n<$rating;$n++){
							print " $text{'ratesymbol'}";
						}
					}
					print "$text{'ratesep'}<a href=\"$script?action=rate&cat=$cathref&url=$url\">$text{'rate'}</a>";
				}
				print "</td></tr><tr><td colspan=2 valign=top>$desc</td></tr>";
				print "<tr><td colspan=2 valign=top><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=-1><i>$surl</i></font></td><td align=right>";
				if($rez_cat eq "yes"){
					$category=~s/\|/ &gt; /gi;
					print "<a href=\"$script?action=cat&name=$cathref\"><font size=-2 face=arial>$category</font></a>";
					$category=~s/ &gt; /\|/gi;
				}
				if($entryextra eq "yes"){
					$ln=$extrahref;
					$ln=~s/<URL>/$url/gi;
					if($rez_cat eq "yes"){
						print "<font size=-2> | </font>";
					}
					print "<font size=-2 face=arial><a href=\"$ln\">$extralink</a></font>";
				}
				print "</td></tr></table></td></tr></table></li></ul>";
			}else{
				print "<ul><li><a href=\"$script?action=click&url=$url&cat=$cathref\"><b>$stitle</b></a><br>$desc<br><font size=-1><i>$url</i></font></ul>";
			}
		}else{
			print "@results[$i]\n";
		}
	}
	if($sitefound==0){
		print "$text{'nomatch'}\n";
	}
	if($#results>9){
		$pg=0;
		$pages="";
		for($i=0;$i<=$#results;$i=$i+10){
			$pg++;
			if($pg-1==int($amt/10)){
				$last=$i-10;
				$next=$i+10;
				$pages.=" <b>$pg</b> |";
			}else{
				$pages.=" <a href=\"$script?action=search&terms=$termshref&amt=$i&case=$case\">$pg</a> |";
			}
		}
		chop($pages);
		print "<p><center>";
		if($pagenumbers ne "yes"){
			print "<table border=0><tr>\n";
		}
		if(int($amt/10)!=0){
			$pages=" <a href=\"$script?action=search&terms=$termshref&amt=$last&adult=$f{'adult'}&fivestar=$f{'fivestar'}&case=$case\">&lt;&lt; Last</a> |$pages";
			if($pagenumbers ne "yes"){
				print "<td width=5></td><form action=\"$script\" method=post><td><input type=hidden name=case value=$case><input type=hidden name=fivestar value=$f{'fivestar'}><input type=hidden name=adult value=$f{'adult'}><input type=hidden name=action value=search><input type=hidden name=terms value=\"$terms\"><input type=hidden name=amt value=$last><input type=submit value=\"$button{'lastpage'}\"></td></form>";
			}
		}
		if($amt+10<=$#results){
			$pages.="| <a href=\"$script?action=search&terms=$termshref&amt=$next&adult=$f{'adult'}&fivestar=$f{'fivestar'}&case=$case\">Next &gt;&gt;</a> ";
			if($pagenumbers ne "yes"){
				print "<td width=5></td><form action=\"$script\" method=post><td><input type=hidden name=case value=$case><input type=hidden name=fivestar value=$f{'fivestar'}><input type=hidden name=adult value=$f{'adult'}><input type=hidden name=action value=search><input type=hidden name=terms value=\"$terms\"><input type=hidden name=amt value=$next><input type=submit value=\"$button{'nextpage'}\"></td></form>";
			}
		}
		if($pagenumbers eq "yes"){
			print "$text{'page'} &nbsp; $pages</center></p>\n";
		}else{
			print "</tr></table>\n";
		}
	}
	print "<img src=\"$pixel\" width=435 height=1 border=0>\n";
	print "</td><td width=110 align=center valign=top>\n";
	$cdbooklink=$terms;
	$cdbookhref=$termshref;
	if($affiliates==2){
		if($showamazon eq 'yes'){
			print "<img src=\"$amazonimage\" width=100 height=70><br><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "Books about:<br>\n";
			print "<a href=http://www.amazon.$amaex/exec/obidos/external-search/002-0394378-2851455?mode=books&keyword=$cdbookhref&tag=$amazonun=Search>$cdbooklink</a><br>\n";
			print "</font><br>&nbsp;<br>\n";
		}
		if($showcdnow eq 'yes'){
			print "<img src=\"$cdnowimage\" width=100 height=70><br><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "CDs about:<br>\n";
			print "<a href=http://cdnow.com/switch/$cdnowun/target=buyweb_products/artfs=$cdbookhref>$cdbooklink</a><br>\n";
			print "</font>\n";
		}
	}else{
		if($showamazon eq 'yes'){
			print "<p><table border=\"2\" cellspacing=\"0\" cellpadding=\"3\" bordercolor=\"#336600\" width=110 height=66>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffcc\">\n";
			print "<b><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">Amazon.$amaex</font></b><br>\n";
			print "</td></tr>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffff\">\n";
			print "<font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "Books about:<br>\n";
			print "<a href=http://www.amazon.$amaex/exec/obidos/external-search/002-0394378-2851455?mode=books&keyword=$cdbookhref&tag=$amazonun=Search>$cdbooklink</a><br>\n";
			print "</font>\n";
			print "</td></tr></table></p>\n";
		}
		if($showcdnow eq 'yes'){
			print "<p><table border=\"2\" cellspacing=\"0\" cellpadding=\"3\" bordercolor=\"#336600\" width=110 height=66>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffcc\">\n";
			print "<b><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">CDNow.com</font></b><br>\n";
			print "</td></tr>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffff\">\n";
			print "<font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "CDs about:<br>\n";
			print "<a href=http://cdnow.com/switch/$cdnowun/target=buyweb_products/artfs=$cdbookhref>$cdbooklink</a><br>\n";
			print "</font>\n";
			print "</td></tr></table></p>\n";
		}
	}
	print "</td><td width=7%>&nbsp;</td></tr></table></center>\n";
	$remotehref=$terms;
	$remotehref=~s/\+/%2B/gi;
	$remotehref=~s/ /\+/gi;
	$remotehref=~s/\&/%26/gi;
	if($showremote eq "yes"){
		print "<p><center><table border=0 width=87%><tr><td align=center><font size=-1>$text{'remotesearch'}<br><a href=\"http://www.altavista.digital.com/cgi-bin/query?pg=q&user=netscape.com&q=$remotehref\">AltaVista</a> | \n";
		print "<a href=\"http://search.aol.com/dirsearch.adp?query=$remotehref\">AOL Search</a> | \n";
		print "<a href=\"http://www.amazon.com/exec/obidos/external-search?tag=odp?keyword=$remotehref\">Amazon.com</a> | \n";
		print "<a href=\"http://search.dejanews.com/dnquery.xp?QRY=$remotehref&defaultOp=AND&svcclass=dncurrent&maxhits=20&ST=QS&format=terse&DBS=1\">DejaNews</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click/mid7101917?siteid=12551471&bfpage=searchbox360x60&cmd=demo_qry&se=befree&oose=1&qry=$remotehref\">Direct Hit</a> | \n";
		print "<a href=\"http://buck.dogpile.com/texis/search?q=$remotehref\">Dogpile</a> | \n";
		print "<a href=\"http://www.euroferret.com/cgi-bin/ferret?DB=ferret&P=$remotehref&B=&THRESHOLD=0\">EuroFerret</a> | \n";
		print "<a href=\"http://www.euroseek.net/query?iflang=uk&query=$remotehref&domain=world&lang=world\">EuroSeek</a><br>\n";
		print "<a href=\"http://search.excite.com/search.gw?search=$remotehref\">Excite</a> | \n";
		print "<a href=\"http://www.alltheweb.com/cgi-bin/search?type=all&query=$remotehref\">Fast Search</a> | \n";
		print "<a href=\"http://www.google.com/search?num=10&query=$remotehref\">Google</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click/goto?bfsiteid=11405412&bfpage=search8&Keywords=$remotehref\">GoTo</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click?siteid=14272070&bfpage=hotbot_big&bfmid=5960107&MT=$remotehref\">HotBot</a> | \n";
		print "<a href=\"http://www.infind.com/infind/infind.exe?query=$remotehref\">Infind</a> | \n";
		print "<a href=\"http://www.infoseek.com/Titles?qt=$remotehref\">Infoseek</a> | \n";
		print "<a href=\"http://www.looksmart.com/r?comefrom=nspanel-search&key=$remotehref&search=1\">LookSmart</a> | \n";
		print "<a href=\"http://www.lycos.com/cgi-bin/pursuit?matchmode=and&cat=lycos&query=$remotehref\">Lycos</a> | \n";
		print "<a href=\"http://search.go2net.com/crawler?general=$remotehref&method=0\">MetaCrawler</a><br>\n";
		print "<a href=\"http://search.netscape.com/cgi-bin/search?search=$remotehref\">Netscape Search</a> | \n";
		print "<a href=\"http://nscp.snap.com/search/directory/results/1,61,nscp-0,00.html?keyword=$remotehref&tag=tt.ns.sb2\">Snap</a> | \n";
		print "<a href=\"http://www.northernlight.com/nlquery.fcg?qr=$remotehref\">Northern Light</a> | \n";
		print "<a href=\"http://www.webcrawler.com/cgi-bin/WebQuery?searchText=$remotehref\">WebCrawler</a> | \n";
		print "<a href=\"http://search.yahoo.com/bin/search?p=$remotehref\">Yahoo</a></font></td></tr></table></center></p>\n";
	}
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=powersearch\"><font size=+1 $navbarfont>$text{'searchfor'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=search&terms=$termshref&adult=$f{'adult'}&fivestar=$f{'fivestar'}\"><font size=+1 $navbarfont>\"$terms\"</font></a>";
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
}
sub Rate2{
	$url=$f{'url'};
	$url=~s/%(..)/pack("c",hex($1))/ge;
	$category=$f{'cat'};
	chomp($category);
	open(FILE,"<$data/data_$category.txt");
	flock(FILE,2);
	@data=<FILE>;
	close(FILE);
	$category=~s/%spa%/ /gi;
	$category=~s/%amp%/\&/gi;
	$category=~s/%pip%/\|/gi;
	foreach $item (@data){
		@splt=split(/}{/,$item);
		$uls=@splt[1];
		$uls=~s/%(..)/pack("c",hex($1))/ge;
		chomp($uls);
		chomp($url);
		if($url eq $uls){
			($clicks,$url,$stitle,$desc,$keys,$cat,$rate,$votes,$junk)=split(/}{/,$item);
			$url=~s/%(..)/pack("c",hex($1))/ge;
			$stitle=~s/%(..)/pack("c",hex($1))/ge;
			$desc=~s/%(..)/pack("c",hex($1))/ge;
			$keys=~s/%(..)/pack("c",hex($1))/ge;
			if(length($stitle)>$titletrunc){
				$stitle=substr "$stitle","",$titletrunc-3; 
				$stitle.="...";
			}
			if(length($url)>$urltrunc){
				$surl=substr "$url","",$urltrunc-3; 
				$surl.="...";
			}else{
				$surl=$url;
			}
			if(length($desc)==$desclength){
				$desc.="...";
			}
			$votes++;
			$rate=$rate+$f{'rating'};
			$item="$clicks}{$url}{$stitle}{$desc}{$keys}{$cat}{$rate}{$votes";
			$item=~s/\n//gi;
		}
		chomp($item);
		push(@newdata,"$item\n");
	}
	open(FILE,">$data/data_$f{'cat'}.txt");
	flock(FILE,2);
	foreach $line (@newdata){
		chomp($line);
		print FILE "$line\n";
	}
	close(FILE);
	print "Content-type: text/html\n\n";
	$|++;
	print "<html><head><title>$title: $text{'rate'} $url</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=rate&cat=$f{'cat'}&url=$f{'url'}\"><font size=+1 $navbarfont>$text{'rate'} $url</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	&Banner('general');
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"rate2\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'rateurl'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<p><center><table border=0><tr><td width=450>";
	if(($rez_cat eq "yes")||($rez_rate eq "yes")){
		print "<ul><li><table border=0 cellpadding=0 cellspacing=0><tr><td><a href=\"$url\"><b>$stitle</b></a></td><td align=right>";
		if($rez_rate eq "yes"){
			if(($rate==0)||($votes==0)){
				$rating=1;
			}else{
				$rating=int($rate/$votes);
				if($rating>5){
					$rating=5;
				}
			}
			if($rating!=0){
				for($n=0;$n<$rating;$n++){
					print " $text{'ratesymbol'}";
				}
			}
			print "$text{'ratesep'}<a href=\"$script?action=rate&cat=$f{'cat'}&url=$url\">$text{'rate'}</a>";
		}
		print "</td></tr><tr><td colspan=2>$desc</td></tr>\n";
		print "<tr><td colspan=2 valign=top><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=-1><i>$url</i></font></td><td align=right>";
		if($rez_cat eq "yes"){
			$category=~s/\|/ &gt; /gi;
			print "<a href=\"$script?action=cat&name=$f{'cat'}\"><font size=-2 face=arial>$category</font></a>";
		}
		if($entryextra eq "yes"){
			$ln=$extrahref;
			$ln=~s/<URL>/$url/gi;
			if($rez_cat eq "yes"){
				print "<font size=-2> | </font>";
			}
			print "<font size=-2 face=arial><a href=\"$ln\">$extralink</a></font>";
		}
		print "</td></tr></table></td></tr></table></li></ul>";
	}else{
		print "<ul><li><a href=\"$url\"><b>$stitle</b></a><br>$desc<br><font size=-1><i>$surl</i></font></ul>\n";
	}
	print "<p><center>$text{'thanksrate'}</center></p>\n";
	print "</td></tr></table></center></p>\n";
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=rate&cat=$f{'cat'}&url=$f{'url'}\"><font size=+1 $navbarfont>$text{'rate'} $url</font></a>";
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
}
sub Rate1{
	$url=$f{'url'};
	$url=~s/%(..)/pack("c",hex($1))/ge;
	$category=$f{'cat'};
	chomp($category);
	&Plugin('rate');
	open(FILE,"<$data/data_$category.txt");
	flock(FILE,2);
	@data=<FILE>;
	close(FILE);
	$category=~s/%spa%/ /gi;
	$category=~s/%amp%/\&/gi;
	$category=~s/%pip%/\|/gi;
	foreach $item (@data){
		@splt=split(/}{/,$item);
		$uls=@splt[1];
		$uls=~s/%(..)/pack("c",hex($1))/ge;
		chomp($uls);
		chomp($url);
		if($url eq $uls){
			($clicks,$url,$stitle,$desc,$keys,$cat,$rate,$votes,$junk)=split(/}{/,$item);
			$url=~s/%(..)/pack("c",hex($1))/ge;
			$stitle=~s/%(..)/pack("c",hex($1))/ge;
			$desc=~s/%(..)/pack("c",hex($1))/ge;
			$keys=~s/%(..)/pack("c",hex($1))/ge;
			if(length($stitle)>$titletrunc){
				$stitle=substr "$stitle","",$titletrunc-3; 
				$stitle.="...";
			}
			if(length($url)>$urltrunc){
				$surl=substr "$url","",$urltrunc-3; 
				$surl.="...";
			}else{
				$surl=$url;
			}
			if(length($desc)==$desclength){
				$desc.="...";
			}
		}
	}
	print "Content-type: text/html\n\n";
	$|++;
	print "<html><head><title>$title: $text{'rate'} $url</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=rate&cat=$f{'cat'}&url=$f{'url'}\"><font size=+1 $navbarfont>$text{'rate'} $url</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	&Banner('general');
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"rate2\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'rateurl'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<p><center><table border=0><tr><td width=450>";
	if(($rez_cat eq "yes")||($rez_rate eq "yes")){
		print "<ul><li><table border=0 cellpadding=0 cellspacing=0><tr><td><a href=\"$url\"><b>$stitle</b></a></td><td align=right>";
		if($rez_rate eq "yes"){
			if(($rate==0)||($votes==0)){
				$rating=0;
			}else{
				$rating=int($rate/$votes);
				if($rating>5){
					$rating=5;
				}
			}
			if($rating!=0){
				for($n=0;$n<$rating;$n++){
					print " $text{'ratesymbol'}";
				}
			}
			print "$text{'ratesep'}<a href=\"$script?action=rate&cat=$f{'cat'}&url=$url\">$text{'rate'}</a>";
		}
		print "</td></tr><tr><td colspan=2>$desc</td></tr>\n";
		print "<tr><td colspan=2 valign=top><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=-1><i>$surl</i></font></td><td align=right>";
		if($rez_cat eq "yes"){
			$category=~s/\|/ &gt; /gi;
			print "<a href=\"$script?action=cat&name=$f{'cat'}\"><font size=-2 face=arial>$category</font></a>";
		}
		if($entryextra eq "yes"){
			$ln=$extrahref;
			$ln=~s/<URL>/$url/gi;
			if($rez_cat eq "yes"){
				print "<font size=-2> | </font>";
			}
			print "<font size=-2 face=arial><a href=\"$ln\">$extralink</a></font>";
		}
		print "</td></tr></table></td></tr></table></li></ul>";
	}else{
		print "<ul><li><a href=\"$url\"><b>$stitle</b></a><br>$desc<br><font size=-1><i>$url</i></font></ul>\n";
	}
	print "</td></tr></table></center></p>\n";
	print "<p><center>";
	print "<select name=rating>\n";
	print "<option value=5 selected>\n";
	print "<option value=5>$text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'}\n";
	print "<option value=5>$text{'rate5'}\n";
	print "<option value=5>\n";
	print "<option value=4>$text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'}\n";
	print "<option value=4>$text{'rate4'}\n";
	print "<option value=4>\n";
	print "<option value=3>$text{'ratesymbol'} $text{'ratesymbol'} $text{'ratesymbol'}\n";
	print "<option value=3>$text{'rate3'}\n";
	print "<option value=3>\n";
	print "<option value=2>$text{'ratesymbol'} $text{'ratesymbol'}\n";
	print "<option value=2>$text{'rate2'}\n";
	print "<option value=2>\n";
	print "<option value=1>$text{'ratesymbol'}\n";
	print "<option value=1>$text{'rate1'}\n";
	print "<option value=1>\n";
	print "</select>\n";
	print "<input type=hidden name=cat value=\"$f{'cat'}\">";
	print "<input type=hidden name=url value=\"$url\">";
	print "<input type=Submit value=\"$button{'rate'}\"></center></p>\n";
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=rate&cat=$f{'cat'}&url=$f{'url'}\"><font size=+1 $navbarfont>$text{'rate'} $url</font></a>";
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
}
sub BrowseCat{
	&Plugin('browsecat');
	$category=$f{'name'};
	$amt=$f{'amt'};
	$cathref=$category;
	$category=~s/%spa%/ /gi;
	$category=~s/%amp%/\&/gi;
	$category=~s/%pip%/\|/gi;
	if($category=~/\|/){
		$issubcat="yes";
	}
	@categories=split(/}{/,$cats);
	@catsdescs=split(/}{/,$catdesc);
	print "Content-type: text/html\n\n";
	$|++;
	$tcategory=$category;
	$tcategory=~s/\|/: /gi;
	print "<html><head><title>$title: $tcategory</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	if($issubcat ne "yes"){
		$topbar="<a href=\"$script?action=cat&name=$cathref\"><font size=+1 $navbarfont>$category</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	}else{
		($backcat,$thissub)=split(/\|/,$category);
		($backcathref,$thissubhref)=split(/%pip%/,$cathref);
		$topbar="<a href=\"$script?action=cat&name=$backcathref%pip%$thissubhref\"><font size=+1 $navbarfont>$thissub</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$script?action=cat&name=$backcathref\"><font size=+1 $navbarfont>$backcat</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	}
	&TopBar;
	&Banner("$category");
	print "<center><table border=0 width=97%><tr><td valign=top>";
	open(FILE,"<$data/data_$cathref.txt");
	flock(FILE,2);
	@data=<FILE>;
	close(FILE);
	sort(@data);
	&Plugin('category');
	$c1=-1;
	$webcount=$#data+1;
	$text{'websites'}=~s/##/$webcount/gi;
	unshift(@data,$text{'websites'});
	if($issubcat ne "yes"){
		$subcatfound=0;
		foreach $item (@categories){
			$c1++;
			($ucat,$subcats)=split(/\|/,$item);
			chomp($ucat);
			if($ucat eq $category){
				($junk,$subcatsdesc)=split(/\|/,$catsdescs[$c1]);
				@subcategories=split(/,/,$subcats);
				@subcategoriesdesc=split(/,/,$subcatsdesc);
				for($t=0;$t<=$#subcategories;$t=$t+2){
					$subhref1=@subcategories[$t];
					$subhref1=~s/ /%spa%/gi;
					$subhref1=~s/\&/%amp%/gi;
					$subhref1=~s/\|/%pip%/gi;
					$subhref2=@subcategories[$t+1];
					$subhref2=~s/ /%spa%/gi;
					$subhref2=~s/\&/%amp%/gi;
					$subhref2=~s/\|/%pip%/gi;
					$sb="<p><table border=0 width=100% cellpadding=0 cellspacing=0><tr><td width=50%><ul><li><a href=\"$script?action=cat&name=$cathref%pip%$subhref1\"><b>@subcategories[$t]</b></a><br>@subcategoriesdesc[$t]</li></ul></td><td width=50%>";
					if(@subcategories[$t+1] ne ""){
						$sb.="<ul><li><a href=\"$script?action=cat&name=$cathref%pip%$subhref2\"><b>@subcategories[$t+1]</b></a><br>@subcategoriesdesc[$t+1]</li></ul>";
					}
					$sb.="</td></tr></table>\n";
					if($subcatspace eq "yes"){
						print "</p>\n";
					}
					push(@subdata,$sb);
					$subcatfound++;
				}		
			}
		}
		if($subcatfound==0){
			unshift(@data,"$text{'nosubs'}\n");
		}else{
			@data=(@subdata,@data);
		}
		$subcatfound=$subcatfound*2;
		$text{'subcategories'}=~s/##/$subcatfound/gi;
		unshift(@data,$text{'subcategories'});
	}
	if(($amt<0)||($amt eq "")){
		$amt=0;
	}
	if($amt>$#data){
		$amt=$#data;
	}
	$a2=$amt+10;
	$a1=$amt;
	if($a1<0){
		$a1=0;
	}
	$sitefound=0;
	for($i=$a1;$i<$a2;$i++){
		if(@data[$i]=~/}{/gi){
			($clicks,$url,$stitle,$desc,$keys,$cat,$rate,$votes,$junk)=split(/}{/,@data[$i]);
			$url=~s/%(..)/pack("c",hex($1))/ge;
			$stitle=~s/%(..)/pack("c",hex($1))/ge;
			$desc=~s/%(..)/pack("c",hex($1))/ge;
			$keys=~s/%(..)/pack("c",hex($1))/ge;
			if(length($stitle)>$titletrunc){
				$stitle=substr "$stitle","",$titletrunc-3; 
				$stitle.="...";
			}
			if(length($url)>$urltrunc){
				$surl=substr "$url","",$urltrunc-3; 
				$surl.="...";
			}else{
				$surl=$url;
			}
			if(length($desc)==$desclength){
				$desc.="...";
			}
			$sitefound++;
			if(($rez_cat eq "yes")||($rez_rate eq "yes")){
				print "<ul><li><table border=0 cellpadding=0 cellspacing=0 width=87%><tr><td valign=top><a href=\"$script?action=click&url=$url&cat=$cathref\"><b>$stitle</b></a></td><td align=right valign=top>";
				if($rez_rate eq "yes"){
					if(($rate==0)||($votes==0)){
						$rating=0;
					}else{
						$rating=int($rate/$votes);
						if($rating>5){
							$rating=5;
						}
					}
					if($rating!=0){
						for($n=0;$n<$rating;$n++){
							print " $text{'ratesymbol'}";
						}
					}
					print "$text{'ratesep'}<a href=\"$script?action=rate&cat=$cathref&url=$url\">$text{'rate'}</a>";
				}
				print "</td></tr><tr><td colspan=2 valign=top>$desc</td></tr>";
				print "<tr><td colspan=2 valign=top><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=-1><i>$surl</i></font></td><td align=right>";
				if($rez_cat eq "yes"){
					$category=~s/\|/ &gt; /gi;
					print "<a href=\"$script?action=cat&name=$cathref\"><font size=-2 face=arial>$category</font></a>";
					$category=~s/ &gt; /\|/gi;
				}
				if($entryextra eq "yes"){
					$ln=$extrahref;
					$ln=~s/<URL>/$url/gi;
					if($rez_cat eq "yes"){
						print "<font size=-2> | </font>";
					}
					print "<font size=-2 face=arial><a href=\"$ln\">$extralink</a></font>";
				}
				print "</td></tr></table></td></tr></table></li></ul>\n\n";
			}else{
				print "<ul><li><a href=\"$script?action=click&url=$url&cat=$cathref\"><b>$stitle</b></a><br>$desc<br><font size=-1><i>$url</i></font></ul>";
			}
		}else{
			print "@data[$i]\n";
		}
	}
	if(($sitefound==0)&&($subcatfound<9)){
		print "$text{'nosites'}\n";
	}
	if($#data>9){
		$pg=0;
		$pages="";
		for($i=0;$i<=$#data;$i=$i+10){
			$pg++;
			if($pg-1==int($amt/10)){
				$last=$i-10;
				$next=$i+10;
				$pages.=" <b>$pg</b> |";
			}else{
				$pages.=" <a href=\"$script?action=cat&name=$cathref&amt=$i\">$pg</a> |";
			}
		}
		chop($pages);
		print "<p><center>";
		if($pagenumbers ne "yes"){
			print "<table border=0><tr>\n";
		}
		if(int($amt/10)!=0){
			$pages=" <a href=\"$script?action=cat&name=$cathref&amt=$last\">&lt;&lt; Last</a> |$pages";
			if($pagenumbers ne "yes"){
				print "<td width=5></td><form action=\"$script\" method=get><td><input type=hidden name=action value=cat><input type=hidden name=name value=$cathref><input type=hidden name=amt value=$last><input type=submit value=\"$button{'lastpage'}\"></td></form>";
			}
		}
		if($amt+10<=$#data){
			$pages.="| <a href=\"$script?action=cat&name=$cathref&amt=$next\">Next &gt;&gt;</a> ";
			if($pagenumbers ne "yes"){
				print "<td width=5></td><form action=\"$script\" method=get><td><input type=hidden name=action value=cat><input type=hidden name=name value=$cathref><input type=hidden name=amt value=$next><input type=submit value=\"$button{'nextpage'}\"></td></form>";
			}
		}
		if($pagenumbers eq "yes"){
			print "$text{'page'} &nbsp; $pages</center></p>\n";
		}else{
			print "</tr></table>\n";
		}
	}
	print "<img src=\"$pixel\" width=435 height=1 border=0>\n";
	print "</td><td width=110 align=center valign=top>\n";
	if($issubcat eq "yes"){
		$cdbooklink=$thissub;
		$remotehref=$thissubhref;
	}else{
		$cdbooklink=$category;
		$remotehref=$cathref;
	}
	$remotehref=~s/\+/%2B/gi;
	$remotehref=~s/ /\+/gi;
	$remotehref=~s/\&/%26/gi;
	$remotehref=~s/%amp%/%26/gi;
	$remotehref=~s/%pip%/%7C/gi;
	$remotehref=~s/%spa%/\+/gi;
	$cdbookhref=$remotehref;
	if($affiliates==2){
		if($showamazon eq 'yes'){
			print "<img src=\"$amazonimage\" width=100 height=70><br><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "Books about:<br>\n";
			print "<a href=http://www.amazon.$amaex/exec/obidos/external-search/002-0394378-2851455?mode=books&keyword=$cdbookhref&tag=$amazonun=Search>$cdbooklink</a><br>\n";
			print "</font><br>&nbsp;<br>\n";
		}
		if($showcdnow eq 'yes'){
			print "<img src=\"$cdnowimage\" width=100 height=70><br><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "CDs about:<br>\n";
			print "<a href=http://cdnow.com/switch/$cdnowun/target=buyweb_products/artfs=$cdbookhref>$cdbooklink</a><br>\n";
			print "</font>\n";
		}
	}else{
		if($showamazon eq 'yes'){
			print "<p><table border=\"2\" cellspacing=\"0\" cellpadding=\"3\" bordercolor=\"#336600\" width=110 height=66>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffcc\">\n";
			print "<b><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">Amazon.$amaex</font></b><br>\n";
			print "</td></tr>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffff\">\n";
			print "<font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "Books about:<br>\n";
			print "<a href=http://www.amazon.$amaex/exec/obidos/external-search/002-0394378-2851455?mode=books&keyword=$cdbookhref&tag=$amazonun=Search>$cdbooklink</a><br>\n";
			print "</font>\n";
			print "</td></tr></table></p>\n";
		}
		if($showcdnow eq 'yes'){
			print "<p><table border=\"2\" cellspacing=\"0\" cellpadding=\"3\" bordercolor=\"#336600\" width=110 height=66>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffcc\">\n";
			print "<b><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">CDNow.com</font></b><br>\n";
			print "</td></tr>\n";
			print "<tr><td align=\"center\" bgcolor=\"#ffffff\">\n";
			print "<font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-2\">\n";
			print "CDs about:<br>\n";
			print "<a href=http://cdnow.com/switch/$cdnowun/target=buyweb_products/artfs=$cdbookhref>$cdbooklink</a><br>\n";
			print "</font>\n";
			print "</td></tr></table></p>\n";
		}
	}
	print "</td><td width=7%>&nbsp;</td></tr></table></center>\n";
	if($showremote eq "yes"){
		print "<p><center><table border=0 width=87%><tr><td align=center><font size=-1>$text{'remotesearch'}<br><a href=\"http://www.altavista.digital.com/cgi-bin/query?pg=q&user=netscape.com&q=$remotehref\">AltaVista</a> | \n";
		print "<a href=\"http://search.aol.com/dirsearch.adp?query=$remotehref\">AOL Search</a> | \n";
		print "<a href=\"http://www.amazon.com/exec/obidos/external-search?tag=odp?keyword=$remotehref\">Amazon.com</a> | \n";
		print "<a href=\"http://search.dejanews.com/dnquery.xp?QRY=$remotehref&defaultOp=AND&svcclass=dncurrent&maxhits=20&ST=QS&format=terse&DBS=1\">DejaNews</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click/mid7101917?siteid=12551471&bfpage=searchbox360x60&cmd=demo_qry&se=befree&oose=1&qry=$remotehref\">Direct Hit</a> | \n";
		print "<a href=\"http://buck.dogpile.com/texis/search?q=$remotehref\">Dogpile</a> | \n";
		print "<a href=\"http://www.euroferret.com/cgi-bin/ferret?DB=ferret&P=$remotehref&B=&THRESHOLD=0\">EuroFerret</a> | \n";
		print "<a href=\"http://www.euroseek.net/query?iflang=uk&query=$remotehref&domain=world&lang=world\">EuroSeek</a><br>\n";
		print "<a href=\"http://search.excite.com/search.gw?search=$remotehref\">Excite</a> | \n";
		print "<a href=\"http://www.alltheweb.com/cgi-bin/search?type=all&query=$remotehref\">Fast Search</a> | \n";
		print "<a href=\"http://www.google.com/search?num=10&query=$remotehref\">Google</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click/goto?bfsiteid=11405412&bfpage=search8&Keywords=$remotehref\">GoTo</a> | \n";
		print "<a href=\"http://service.bfast.com/bfast/click?siteid=14272070&bfpage=hotbot_big&bfmid=5960107&MT=$remotehref\">HotBot</a> | \n";
		print "<a href=\"http://www.infind.com/infind/infind.exe?query=$remotehref\">Infind</a> | \n";
		print "<a href=\"http://www.infoseek.com/Titles?qt=$remotehref\">Infoseek</a> | \n";
		print "<a href=\"http://www.looksmart.com/r?comefrom=nspanel-search&key=$remotehref&search=1\">LookSmart</a> | \n";
		print "<a href=\"http://www.lycos.com/cgi-bin/pursuit?matchmode=and&cat=lycos&query=$remotehref\">Lycos</a> | \n";
		print "<a href=\"http://search.go2net.com/crawler?general=$remotehref&method=0\">MetaCrawler</a><br>\n";
		print "<a href=\"http://search.netscape.com/cgi-bin/search?search=$remotehref\">Netscape Search</a> | \n";
		print "<a href=\"http://nscp.snap.com/search/directory/results/1,61,nscp-0,00.html?keyword=$remotehref&tag=tt.ns.sb2\">Snap</a> | \n";
		print "<a href=\"http://www.northernlight.com/nlquery.fcg?qr=$remotehref\">Northern Light</a> | \n";
		print "<a href=\"http://www.webcrawler.com/cgi-bin/WebQuery?searchText=$remotehref\">WebCrawler</a> | \n";
		print "<a href=\"http://search.yahoo.com/bin/search?p=$remotehref\">Yahoo</a></font></td></tr></table></center></p>\n";
	}
	if($issubcat ne "yes"){
		$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=cat&name=$cathref\"><font size=+1 $navbarfont>$category</font></a>";
		$remotehref=$category;
	}else{
		($backcat,$thissub)=split(/\|/,$category);
		($backcathref,$thissubhref)=split(/%pip%/,$cathref);
		$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=cat&name=$backcathref\"><font size=+1 $navbarfont>$backcat</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=cat&name=$backcathref%pip%$thissubhref\"><font size=+1 $navbarfont>$thissub</font></a>";
		$remotehref=$thissub;
	}
	&BottomBar;
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
	exit;
}
sub ShowReFrame{
	$f{'url'}=~s/%(..)/pack("c",hex($1))/ge;
	&Plugin('reframe');
	open(FILE,"<$rebarpath");
	flock(FILE,2);
	@refile=<FILE>;
	close(FILE);
	print "content-type:text/html\n\n";
	foreach $line (@refile){
		chomp($line);
		$line=~s/<!--#url-->/$f{'url'}/gi;
		$line=~s/<!--#back-->/$ENV{'HTTP_REFERER'}/gi;
		print "$line\n";
	}
}
sub HomeClick{
	if($rebar eq "on"){
		print "content-type:text/html\n\n";
		print "<html><head><title>$f{'title'}</title></head>\n";
		print "<frameset rows=35,* border=0><frame src=\"$script?action=showreframe&url=$f{'url'}\" border=0 scrolling=no framespacing=0>\n";
		print "<frame src=\"$f{'url'}\" border=0></frameset></html>\n";
	}else{
		$f{'url'}=~s/%(..)/pack("c",hex($1))/ge;
		print "location:$f{'url'}\n\n";
	}
}
sub URLClick{
	&Plugin('urlclick');
	$url=$f{'url'};
	$url=~s/%(..)/pack("c",hex($1))/ge;
	$category=$f{'cat'};
	chomp($category);
	open(FILE,"<$data/data_$category.txt");
	flock(FILE,2);
	@data=<FILE>;
	close(FILE);
	foreach $item (@data){
		@splt=split(/}{/,$item);
		$uls=@splt[1];
		$uls=~s/%(..)/pack("c",hex($1))/ge;
		chomp($uls);
		chomp($url);
		if($url eq $uls){
			$osplt=@splt[0];
			$newline=@splt[0]+1;
			$item=~s/$osplt}{//gi;
			$newline="$newline}{$item";
			push(@newfile,"$newline");
			$stitle=@splt[2];
		}else{
			push(@newfile,"$item");
		}
	}
	open(FILE,">$data/data_$category.txt");
	flock(FILE,2);
	foreach $line (@newfile){
		chomp($line);
		print FILE "$line\n";
	}
	close(FILE);
	if($rebar eq "on"){
		print "content-type:text/html\n\n";
		print "<html><head><title>$stitle</title></head>\n";
		print "<frameset rows=35,* border=0><frame src=\"$script?action=showreframe&url=$url\" border=0 scrolling=no framespacing=0>\n";
		print "<frame src=\"$url\" border=0></frameset></html>\n";
	}else{
		print "location:$url\n\n";
	}
}
sub Spider{
	&Plugin('spider');
	$url=$f{'url'};
	$url=~s/%(..)/pack("c",hex($1))/ge;
	opendir(DIR,$data);
	@files=readdir(DIR);
	closedir(DIR);
	foreach $line (@files){
		chomp($line);
		if(($line ne ".")&&($line ne "..")){
			open(FILE,"<$data/$line");
			flock(FILE,2);
			@urls=<FILE>;
			close(FILE);
			foreach $item (@urls){
				@splt=split(/}{/,$item);
				$uls=@splt[1];
				$uls=~s/%(..)/pack("c",hex($1))/ge;
				chomp($uls);
				chomp($url);
				if($url eq $uls){
					&Error($text{'urlindexed'});
				}
			}
		}
	}
	if($lwp eq "on"){
		use LWP::UserAgent;
		use HTTP::Request;
		use HTTP::Response; 	
		$ua = LWP::UserAgent->new();
		$ua->agent("$spider");
		$request = HTTP::Request->new(GET => $url);
		$response = $ua->request($request);
		$dolwp=$response->is_error();
		if($dolwp){
			print "Content-type: text/html\n\n";
			print "<html><head><title>$title: $title{'addurl'}</title></head><body $bodytag>\n";
			open(HEAD,"<$header");
			@top=<HEAD>;
			close(HEAD);
			print "@top";
			$topbar="<a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
			&TopBar;
			open(FILE,"<$banner");
			@advert=<FILE>;
			close(FILE);
			print "<p><center>@advert</center></p>";
			print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"addurl\">\n";
			print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'error'}</font></td></tr><tr><td>\n";
			print "<TABLE PADDING=5>\n";
			print "<TR><TD>\n";
			print "$text{'addurlerror'}";
			print "<p><center><input type=Submit value=\"$button{'addurl'}\"></center></p>\n";
			print "</td></tr></table></td></tr></table></center></p>\n";
			$bottombar="<a href=\"$homescript\"><font $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a>";
			&BottomBar;
			print "</form>\n";
			open(FOOT,"<$footer");
			@bottom=<FOOT>;
			close(FOOT);
			print "@bottom";
			print "</body></html>\n";
			exit;
		}
		$stitle=$response->title();
		$page=$response->content();
		$page=~s/\n/ /gi;
		$page=~s/\r/ /gi;
		$page=~s/\c/ /gi;
		$page=~s/<script.*\/script>//gi;
		$page=~s/<style.*\/style>//gi;
		while($page=~/  /){
			$page=~s/  / /gi;
		}
		$nometa=$page;
		$page=~s/>/\>*brkhre\*/gi;
		@tags=split(/\*brkhre\*/,$page);
		foreach $tag (@tags){
			if($tag=~/<meta name=\"?description\"? content=\".*\">/gi){
				$tag=~s/<meta name=\"?description\"? content="//gi;
				$tag=~s/">//gi;
				$tag=~s/</&lt;/gi;
				$tag=~s/>/&gt;/gi;
				$desc=$tag;
			}
			if($tag=~/<meta name=\"?keywords\"? content=\".*\">/gi){
				$tag=~s/<meta name=\"?keywords\"? content="//gi;
				$tag=~s/">//gi;
				$tag=~s/</&lt;/gi;
				$tag=~s/>/&gt;/gi;
				$keys=$tag;
			}
		}
		$nometa=~s/<([^>]|\n)*>//gi;
		$nometa=~s/\&nbsp;/ /g;
		while($nometa=~/	/){
			$nometa=~s/	/ /gi;
		}
		while($nometa=~/  /){
			$nometa=~s/  / /g;
		}
		chomp($desc);
		chomp($keys);
		if($desc eq ''){
			$desc=substr "$nometa","",$desclength;
		}else{
			$desc=substr "$desc","",$desclength; 
		}
		if($keys eq ''){
			$keys=substr "$nometa","",$desclength; 
		}else{
			$keys=substr "$keys","",$keyslength; 
		}
	}else{
		$desc=$f{'desc'};
		$keys=$f{'keys'};
		$stitle=$f{'title'};
	}
	$desc=~s/}{//gi;
	chomp($desc);
	$keys=~s/}{//gi;
	chomp($keys);
	$stitle=~s/}{//gi;
	$stitle=substr "$stitle","",$titletrunc; 
	chomp($stitle);
	if(($desc eq '')||($desc eq ' ')){
		$desc=$text{'nodesc'};
	}
	if(($stitle eq '')||($stitle eq ' ')){
		$stitle=$text{'notitle'};
	}
	chomp($f{'category'});
	$category=$f{'category'};
	$f{'category'}=~s/ /%spa%/gi;
	$f{'category'}=~s/\&/%amp%/gi;
	$f{'category'}=~s/\|/%pip%/gi;
	print "Content-type: text/html\n\n";
	print "<html><head><title>$title: $title{'addurl'}</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	open(FILE,"<$banner");
	@advert=<FILE>;
	close(FILE);
	print "<p><center>@advert</center></p>";
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"addurl\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'addurl'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<p><center><table border=0><tr><td width=450>";
	if(($rez_cat eq "yes")||($rez_rate eq "yes")){
		print "<ul><li><table border=0 cellpadding=0 cellspacing=0><tr><td><a href=\"$url\"><b>$stitle</b></a></td><td align=right>";
		if($rez_rate eq "yes"){
			print "$text{'ratesep'}<a href=\"$script?action=rate&cat=$f{'category'}&url=$url\">$text{'rate'}</a>";
		}
		print "</td></tr><tr><td colspan=2>$desc</td></tr>\n";
		print "<tr><td colspan=2 valign=top><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=-1><i>$url</i></font></td><td align=right>";
		if($rez_cat eq "yes"){
			$category=~s/\|/ &gt; /gi;
			print "<a href=\"$script?action=cat&name=$f{'category'}\"><font size=-2 face=arial>$category</font></a>";
		}
		if($entryextra eq "yes"){
			$ln=$extrahref;
			$ln=~s/<URL>/$url/gi;
			if($rez_cat eq "yes"){
				print "<font size=-2> | </font>";
			}
			print "<font size=-2 face=arial><a href=\"$ln\">$extralink</a></font>";
		}
		print "</td></tr></table></td></tr></table></li></ul>";
	}else{
		print "<ul><li><a href=\"$url\"><b>$stitle</b></a><br>$desc<br><font size=-1><i>$url</i></font></ul>\n";
	}
	open(FILE,">>$data/data_$f{'category'}.txt");
	flock(FILE,2);
	print FILE "0}{$url}{$stitle}{$desc}{$keys}{$f{'category'}}{0}{0\n";
	close(FILE);
	open(FILE,">$lastsub");
	flock(FILE,2);
	print FILE "$url\n$stitle\n$desc";
	close(FILE);
	print "</td></tr></table></center></p>\n";
	print "$text{'addurldone'}";
	print "<p><center><input type=Submit value=\"$button{'addurl'}\"></center></p>\n";
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a>";
	&BottomBar;
	print "</form>\n";
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
	if($rqmail eq 'yes'){
		open (FILE, ">>$emailfile");
		flock(FILE, 2);
		print FILE "$f{'email'}\n";
		close(FILE);
		open (MAIL, "|$mail_prog -t");
		print MAIL "To: $f{'email'}\n";
		print MAIL "Reply-to: $remail\n";
		print MAIL "From: $remail\n";
		print MAIL "Subject: $emailtitle\n";
		print MAIL "\n\n";
		print MAIL "$text{'thanksemail'}";
		close(MAIL);
	}
	exit;
}
sub AddURL{
	&Plugin('addurl');
	print "Content-type: text/html\n\n";
	print "<html><head><title>$title: $title{'addurl'}</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	open(FILE,"<$banner");
	@advert=<FILE>;
	close(FILE);
	print "<p><center>@advert</center></p>";
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"spider\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'addurl'}</font></td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<table border=0><tr><td colspan=3 align=center>\n";
	if ($lwp eq "on"){
		print "<p><table border=0><tr><td>$text{'auspider'}</td><td><img src=\"$spiderimg\" width=40 height=72></td></tr></table></p>\n";
	}else{
		print "<p><table border=0><tr><td>$text{'aunolwp'}</td><td><img src=\"$spiderimg\" width=40 height=72></td></tr></table></p>\n";
	}
	print "</td></tr>\n";
	print "<tr><td>$text{'category'}</td><td colspan=2><select name=\"category\"><option value=\"none\">----------------------------------------------------------------------------\n";
	print "<option value=\"none\" selected>\n";
	foreach $op (@cats){
		chomp($op);
		($opc,$ops)=split(/\|/,$op);
		@subs=split(/,/,$ops);
		print "<option value=\"$opc\">$opc\n";
		foreach $su (@subs){
			print "<option value=\"$opc|$su\">$subcatsep$su\n";
		}
	}
	print "<option value=\"none\">\n";
	print "<option value=\"none\">----------------------------------------------------------------------------</select></td></tr>\n";
	if($rqmail eq 'yes'){
		print "<tr><td>$text{'email'}</td><td colspan=2><input type=text name=\"email\" size=41 value=\"\"></td></tr>\n";
	}
	if($lwp eq "on"){
		print "<tr><td>$text{'yoururl'}</td><td><input type=text name=\"url\" size=30 value=\"http://\"></td><td><input type=Submit value=\"$button{'addurl'}\"></td></tr>\n";
		print "</table>\n";
	}else{
		print "<tr><td>$text{'yoururl'}</td><td><input type=text name=\"url\" size=41 value=\"http://\"></td><td>\n";
		print "</td></tr><tr><td>\n";
		print "$text{'title'}\n";
		print "</td><td>\n";
		print "<input type=text name=\"title\" size=41 value=\"\">\n";
		print "</td></tr><tr><td>\n";
		print "$text{'desc'}\n";
		print "</td><td>\n";
		print "<textarea name=\"desc\" rows=3 cols=39 wrap></textarea>\n";
		print "</td></tr><tr><td>\n";
		print "$text{'keys'}\n";
		print "</td><td>\n";
		print "<input type=text name=\"keys\" maxsize=100 size=41>\n";
		print "</td></tr><tr><td colspan=2><center><input type=Submit value=\"$button{'addurl'}\"></center></td></tr></table>\n";
	}
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><a href=\"$script?action=addurl\"><font size=+1 $navbarfont>$title{'addurl'}</font></a>";
	&BottomBar;
	print "</form>\n";
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
	exit;
}
sub Error{
	&Plugin('error');
	print "Content-type: text/html\n\n";
	print "<html><head><title>$title: $title{'error'}</title></head><body $bodytag>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top";
	$topbar="<font size=+1 $navbarfont>$title{'error'}</font><font size=+1 $navbarfont> &lt; </font><a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a>";
	&TopBar;
	open(FILE,"<$banner");
	@advert=<FILE>;
	close(FILE);
	print "<p><center>@advert</center></p>";
	print "<form action=\"$script\" method=post><input type=hidden name=\"action\" value=\"addurl\">\n";
	print "<p><center><table border=$borderwidth cellpadding=1 cellspacing=0 bgcolor=$clientwindow><tr><td bgcolor=$titlebar><font face=arial color=$titlecolor size=\"-2\">$window{'error'}</font></td></tr><tr><td valign=center>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "$_[0]";
	print "</td></tr></table></td></tr></table></center></p>\n";
	$bottombar="<a href=\"$homescript\"><font size=+1 $navbarfont>$title{'home'}</font></a><font size=+1 $navbarfont> &gt; </font><font size=+1 $navbarfont>$title{'error'}</font>";
	&BottomBar;
	print "</form>\n";
	open(FOOT,"<$footer");
	@bottom=<FOOT>;
	close(FOOT);
	print "@bottom";
	print "</body></html>\n";
	exit;
}
sub Banner{
	$search="$_[0]";
	&Plugin('specialad');
	if($specialad ne "yes"){
		open(ADVERT,"<$banner");
		@ad=<ADVERT>;
		close(ADVERT);
		if((@ad[0] ne '')||(@ad[1] ne '')||(@ad[2] ne '')){
			print "<p><center><table border=0 cellpadding=10><tr><td>@ad</td></tr></table></center></p>\n";
		}
	}else{
		&Plugin("showad|$search");
	}
}
sub TopBar{
	&Plugin('topbar');
	print "<p><center><table border=0 bgcolor=\"$navbarbc\" width=90% cellspacing=0><tr><td align=left><img src=\"$simage\" width=50 height=25></td><td align=right>$topbar</td></tr></table></center></p>\n";
}
sub BottomBar{
	&Plugin('bottombar');
	print "<p><center><table border=0 bgcolor=\"$navbarbc\" width=90% cellspacing=0><tr><td align=left>$bottombar</td><td align=right><img src=\"$simage\" width=50 height=25></td></tr></table></center></p>\n";
}